<?php if (!defined('PmWiki')) exit();
/*
 * Codeblock - Yet another source code syntax highlighter
 *             for PmWiki 2.0 by D.Faure
 * based on Beautifier Cookbook
 * Copyright 2003-2004 by Jason Perkins (jason@sim8.com)
 * Beautifier module written by and (C) Mike Jewell
 * Rewritten 2004-12-02 for PmWiki 2.0 by Patrick R. Michaud 
 *    (pmichaud@pobox.com)
 * See http://www.pmichaud.com/wiki/Cookbook/Beautifier for info.
 */
SDV($CodeWrapLen, 65);
SDV($BEAUT_PATH, dirname(__FILE__) . "/beautifier/php");
SDV($BeautifierOutputType, 'HTML');

global $KeepToken;
Markup("code", "block",
"/\\(:code(=(\\S+))?(\\s+(ln))?(\\s+wrap=(\\d+))?\\s*:\\)\\s*$KeepToken(\\d.*?)$KeepToken/e",
"do_codeblock('$2', '$4', '$6', '$7')");

function do_codeblock($language, $lineNum, $wrapLen, $keepIndex) {
  global $KPV, $CodeWrapLen;
  global $BEAUT_PATH, $BeautifierOutputType, $HTMLStylesFmt;

  $file_lang = $BEAUT_PATH . "/HFile/HFile_$language.php";
  if($language && (file_exists($file_lang))) {
    if ($BeautifierOutputType != 'css') $BeautifierOutputType = 'HTML';

    include_once($BEAUT_PATH . "/Beautifier/CoreNoIndent.php");
    include_once($BEAUT_PATH . "/Output/Output_HTML.php");
    include_once($BEAUT_PATH . "/Output/Output_css.php");
    include_once($file_lang);

    eval("\$hf = new HFile_$language();");
    eval("\$beautifier = new Core(\$hf, new Output_$BeautifierOutputType());");

    $source = str_replace(array('&lt;', '&gt;', '&amp;'),
                          array('<',    '>',    '&'),
                          $KPV[$keepIndex]);

    if($wrapLen) $source = wordwrap($source, $wrapLen);
    $source = $beautifier->highlight_text($source);

    if(!$lineNum)
      $output = $source;
    else {
      $lines = explode("\n", $source);
      $count = count($lines);
      $numFmt = "<span class='codeblock_ln'>%" . strlen($count) . "d:</span> ";

      $num = 1;
      for ($i = 0; $i < $count - 1; $i++) {
        if((($i == 0) || ($i == $count - 1)) && (strlen($lines[0]) == 0))
          continue;
  
        $lines[$i] = sprintf($numFmt, $num++) . $lines[$i];
      }
      $output = implode("\n", $lines);
    }
    
  }
  else {
    $source = $KPV[$keepIndex];
  
    if(!$lineNum) {
      if(! $wrapLen) $wrapLen = $CodeWrapLen;
      $output = wordwrap($source, $wrapLen);
    }
    else {
      $lines = explode("\n", $source);
      $count = count($lines);
      $numFmt = "<span class='codeblock_ln'>%" . strlen($count) . "d:</span> ";
      $numLen = strlen($count) + 2; // 2 = strlen(": ")
      $filler = "\n" . str_repeat(" ", $numLen);
  
      $num = 1;
      for ($i = 0; $i < $count - 1; $i++) {
        if((($i == 0) || ($i == $count - 1)) && (strlen($lines[0]) == 0))
          continue;
  
        if(! $wrapLen) $wrapLen = $CodeWrapLen;
        $l = wordwrap($lines[$i], $numLen + $wrapLen);
        $lines[$i] = sprintf($numFmt, $num++) . str_replace("\n", $filler, $l);
      }
      $output = implode("\n", $lines);
    }
  }
  return Keep("<div class='codeblock'><pre>" . $output . "</pre></div>");
}
?>
